$(function () {
  var jsTreeMaked = false;

  $('#projectSelect').bind('change', function(event, ui) {
    console.log('change-----------');
    if (jsTreeMaked) {
      $('#tree').jstree().destroy();
    }
    var prjId = $('#projectSelect').val();
    $('#tree').jstree({
      core: {
        animation: 0,
        check_callback : function(o, n, p, i, m) {
          console.log('check_callback---------');
          console.log(o);
          console.log(n);
          console.log(p);
          console.log(i);
          console.log(m);
          return true;
        },
        themes : { stripes: true },
        data : {
          url: function (node) {
            console.log('url----------------------');
            console.log(node);
            return node.id === '#' ? 'tree' : 'tree_children';
          },
          type: 'POST',
          cache: false,
          data: function (node) {
            console.log('data----------------------');
            console.log(node);
            return {
              id: node.id,
              projectId: prjId
            };
          }
        }
      },
      types: {
        folder: {
          icon: 'jstree-folder',
          valid_children: ['folder', 'file']
        },
        file: {
          icon: 'jstree-file',
          valid_children: []
        }
      },
      plugins: [
        'contextmenu', 'dnd', 'search',
        'state', 'types', 'wholerow'
      ],
      contextmenu: {
        items: function(node) {
          return {
            run: {
              label: UiUtil.getMessage('contextRun'),
              action: function(obj) {
                console.log(obj);
                $.ajax({
                  url: '/runJasmine',
                  type: 'POST',
                  cache : false,
                  data: {
                    projectId: $('#projectSelect').val(),
                    id: node.id
                  },
                  timeout: 10000,

                  // 送信前
                  beforeSend: function(xhr, settings) {
                    // ボタンを無効化し、二重送信を防止
                    // $('#btnUpdateProject').attr('disabled', true);
                  },
                  // 応答後
                  complete: function(xhr, textStatus) {
                    // ボタンを有効化し、再送信を許可
                    // $('#btnUpdateProject').attr('disabled', false);
                  },
                  
                  // 通信成功時の処理
                  success: function(result, textStatus, xhr) {
                    console.log(result);
                    var tbody = $('#testresult').find('tbody');
                    tbody.empty();
                    for (var i = 0; i < result.length; ++i) {
                      console.log(result[i]);
                      tbody.append(
                        $('<tr data-tt-id="'+ i +'">')
                            .append($('<td>').text(result[i].name))
                            .append($('<td>').text(''))
                            .append($('<td>').text(''))
                            .append($('<td>').text(''))
                            .append($('<td>').text(''))
                            .append($('<td>').text(''))
                      );
                      for (var j = 0; j < result[i].data.length; ++j) {
                        tbody.append(
                          $('<tr data-tt-id="'+ i + '.' + j +'" data-tt-parent-id="'+ i +'">')
                            .append($('<td>').text(result[i].data[j].name))
                            .append($('<td>').text(result[i].data[j].time))
                            .append($('<td>').text(result[i].data[j].tests))
                            .append($('<td>').text(result[i].data[j].errors))
                            .append($('<td>').text(result[i].data[j].failures))
                            .append($('<td>').text(result[i].data[j].timestamp))
                        );
                        if (result[i].data[j].testcase) {
                          for (var k = 0; k < result[i].data[j].testcase.length; ++k) {
                            var failure = '';
                            if (result[i].data[j].testcase[k].failure) {
                              failure = UiUtil.htmlEscape(result[i].data[j].testcase[k].failure);
                            }
                            tbody.append(
                              $('<tr data-tt-id="'+ i + '.' + j + '.' + k +'" data-tt-parent-id="' + i + '.' + j +'">')
                                .append($('<td>').text(result[i].data[j].testcase[k].name))
                                .append($('<td>').text(result[i].data[j].testcase[k].time))
                                .append($('<td colspan="4">').html(failure))
                            );
                          }
                        }
                      }
                    }
                    $("#testresult").treetable({ expandable: true }, true);
                    $("#testresult").treetable('expandAll');
                    /*
                    if (result.error) {
                       $.msgBox({content:result.error, type: 'error'});
                    } else {
                       $('#dlgEditProject').dialog('close');
                       $(location).attr('href', '/project');
                    }
                    */
                  },
                  
                  // 通信失敗時の処理
                  error: function(xhr, textStatus, error) {
                    if (!error) {
                      error = 'ConnectError';
                    }
                    $.msgBox({content:error, type: 'error'});
                  }
                });
              }
            }
          };
        }
      }
    });
    jsTreeMaked = true;
  });

  var options = $('#projectSelect').find('option');
  if (options.length) {
    $('#projectSelect').val($(options[0]).val()).trigger('change');;
  }
});
