$(function () {
  /**
   * パスの追加ボタン
   */
  function addPathFunc() {
    var dlg = $(this).parents(".dialog");
    var path = dlg.find('#inputPath').val();
    dlg.find('#inputPath').val('');
    dlg.find('#selectPath').append($('<option>').html(path).val(path));
  }
  /**
   * パスの削除ボタン
   */
  function delPathFunc() {
    var dlg = $(this).parents(".dialog");
    dlg.find('#selectPath > option:selected').remove();
  }

  $('#dlgEditProject').find('#addPath').click(addPathFunc);
  $('#dlgEditProject').find('#deletePath').click(delPathFunc);
  $('#dlgAddProject').find('#addPath').click(addPathFunc);
  $('#dlgAddProject').find('#deletePath').click(delPathFunc);




  // 編集ダイアログの表示
  $('.editProject').button();
  var editPrjId = null;
  $('.editProject').bind('click', function(event, ui) {
    var dlg = $('#dlgEditProject');
    var btn = $(this);
    var tr = $(this).parents('tr', '#projectTable');
    editPrjId = tr.attr('prjId');
    var prjName = tr.find('[field="projectName"]').text();

    dlg.find('#projectName').val(prjName);
    var select = dlg.find('#selectPath');
    select.empty();
    var pathlist = tr.find('[field="path"]').find('p');
    for (var i = 0; i < pathlist.length; ++i) {
      select.append($('<option>').html($(pathlist[i]).text()).val($(pathlist[i]).text()));
    }

    dlg.dialog({modal:true});
  });
  $('#dlgEditProject').find('#btnUpdateProject').click(function() {
    var dlg = $('#dlgEditProject');
    var projectName = dlg.find('#projectName').val();
    var selectPath =  dlg.find('#selectPath > option');
    var selected = [];
    for (var i = 0; i < selectPath.length; ++i) {
      selected.push(selectPath[i].value);
    }
    $.ajax({
      url: '/project/update',
      type: 'POST',
      cache : false,
      data: {
        projectId: editPrjId,
        projectName: projectName,
        selectPath: selected
      },
      timeout: 10000,

      // 送信前
      beforeSend: function(xhr, settings) {
        // ボタンを無効化し、二重送信を防止
        $('#btnUpdateProject').attr('disabled', true);
      },
      // 応答後
      complete: function(xhr, textStatus) {
        // ボタンを有効化し、再送信を許可
        $('#btnUpdateProject').attr('disabled', false);
      },
      
      // 通信成功時の処理
      success: function(result, textStatus, xhr) {
        if (result.error) {
           $.msgBox({content:result.error, type: 'error'});
        } else {
           $('#dlgEditProject').dialog('close');
           $(location).attr('href', '/project');
        }
      },
      
      // 通信失敗時の処理
      error: function(xhr, textStatus, error) {
        if (!error) {
          error = 'ConnectError';
        }
        $.msgBox({content:error, type: 'error'});
      }
    });
  });

  // 削除処理
  $('.deleteProject').button();
  $('.deleteProject').bind('click', function(event, ui) {
    var btn = $(this);
    var tr = $(this).parents('tr', '#projectTable');
    var prjId = tr.attr('prjId');
    var prjName = tr.find('[field="projectName"]').text();
    var msg = UiUtil.getMessage('confirmDelete');

    $.msgBox({
      content: UiUtil.format(msg, prjName) ,
      type: 'confirm',
      buttons: [
        {value: 'Ok'},
        {value: 'Cancel'}
      ],
      success: function(result) {
        if (result !== 'Ok') {
          return;
        }
        $.ajax({
          url: '/project/delete',
          type: 'POST',
          cache : false,
          data: {
            projectId: prjId
          },
          timeout: 10000,

          // 送信前
          beforeSend: function(xhr, settings) {
            // ボタンを無効化し、二重送信を防止
            btn.attr('disabled', true);
          },
          // 応答後
          complete: function(xhr, textStatus) {
            // ボタンを有効化し、再送信を許可
            btn.attr('disabled', false);
          },
          
          // 通信成功時の処理
          success: function(result, textStatus, xhr) {
            console.log(result);
            if (result.error) {
               $.msgBox({content:result.error, type: 'error'});
            } else {
               $(location).attr('href', '/project');
            }
          },
          
          // 通信失敗時の処理
          error: function(xhr, textStatus, error) {
            if (!error) {
              error = 'ConnectError';
            }
            $.msgBox({content:error, type: 'error'});
          }
        });
      }
    });
  });

  // 追加ダイアログの表示
  $('#btnShowAddDialog').click(function() {
    $('#dlgAddProject').dialog({modal:true});
  });

  $('#btnAddProject').click(function() {
    var dlg = $('#dlgAddProject');
    var projectName = dlg.find('#projectName').val();
    var selectPath =  dlg.find('#selectPath > option');
    var selected = [];
    for (var i = 0; i < selectPath.length; ++i) {
      selected.push(selectPath[i].value);
    }
    $.ajax({
      url: '/project/add',
      type: 'POST',
      cache : false,
      data: {
        projectName: projectName,
        selectPath: selected
      },
      timeout: 10000,

      // 送信前
      beforeSend: function(xhr, settings) {
        // ボタンを無効化し、二重送信を防止
        $('#btnAddProject').attr('disabled', true);
      },
      // 応答後
      complete: function(xhr, textStatus) {
        // ボタンを有効化し、再送信を許可
        $('#btnAddProject').attr('disabled', false);
      },
      
      // 通信成功時の処理
      success: function(result, textStatus, xhr) {
        if (result.error) {
           $.msgBox({content:result.error, type: 'error'});
        } else {
           $('#dlgAddProject').dialog('close');
           $(location).attr('href', '/project');
        }
      },
      
      // 通信失敗時の処理
      error: function(xhr, textStatus, error) {
        if (!error) {
          error = 'ConnectError';
        }
        $.msgBox({content:error, type: 'error'});
      }
    });
  });
});
