var db = require('../models');
var message = require('./message.js');
var async = require('async');


/**
 * gUNV̎s
 * @param{Array} tasks ֐̈ꗗ
 * @param{function} callback R[obN֐
 *
 */
function _doTransaction(tasks, callback) {
  var trn = null;
  var beginTrnFnc = function(next) {
    db.sequelize.transaction(function(t) {
      trn = t;
      next(null, trn);
    }).error(function(error) {
      next(error);
    });
  };
  tasks.splice(0, 0, beginTrnFnc);

  async.waterfall(tasks, function(err) {
    if (err) {
      if (trn) {
        trn.rollback();
      }
      var json = JSON.stringify({
        result: false,
        error: err
      });
      callback(json);
      return;
    }
    trn.commit();
    var json = JSON.stringify({result:true});
    callback(json);
  });
}

module.exports = {
  doTransaction: _doTransaction
};
